﻿Global hStdOutput.l=GetStdHandle_(#STD_OUTPUT_HANDLE)
Global dBytesWritten.l=0

Procedure.a xorw(a.a,w.u)
  a=a!(w&255)
  a=a!(w>>8)
  ProcedureReturn a
EndProcedure

Procedure.s fixname(f$)
  w$=":/?*<>|\"+Chr(34)
  For i=1 To Len(w$)
    f$=ReplaceString(f$,Mid(w$,i,1),"_")
  Next i
  ProcedureReturn f$
EndProcedure

Procedure conmsg(szMsg.s)
  ;        szMsg.s="Error creating file "+outf
  If hStdOutput<>#INVALID_HANDLE_VALUE
    WriteConsole_(hStdOutput,@szMsg,Len(szMsg),@dBytesWritten,0)
    ;   Else
    ;     MessageRequester("Info",szMsg,#PB_MessageRequester_Ok )
  EndIf
EndProcedure

If CountProgramParameters()
  If ReadFile(0,ProgramParameter(0))
    While Not Eof(0)
      c.a=0;checksum
      l.u=ReadWord(0);length of block
      If l<>19
        conmsg("Not a header")
        Break
      Else
        fb.a=ReadAsciiCharacter(0)
        c=c!fb
        If fb<>0
          conmsg("not a header")
          Break
        Else
          ;header,3-code
          h.a=ReadAsciiCharacter(0)
          c=c!h
          ;name
          f$=""
          For i=1 To 10
            ch.a=ReadAsciiCharacter(0)
            c=c!ch
            If ch>=32 And ch<=127
              f$+Chr(ch)
            Else
              f$=f$+"("+Str(ch)+")"
            EndIf
          Next i
          
          bl.u=ReadWord(0);len
          c=xorw(c,bl)
          sa.u=ReadWord(0);adr
          c=xorw(c,sa)
          pa1.u=ReadWord(0);par1
          c=xorw(c,pa1)
          csu.a=ReadAsciiCharacter(0);checksum
          
          If c<>csu
            conmsg("wrong header checksum for "+F$)
            Break
          Else
            ;2nd block
            fl.u=ReadWord(0);len 2nd block,-2 flagbyte and checksum
            fb.a=ReadAsciiCharacter(0);flagbyte must be 255
            
            c.a=fb
            
            f$=fixname(f$)
            Select h;1-array,2-string
              Case 0: e$=".B"
              Case 3: e$=".C"
              Default: e$="."+Str(h)
            EndSelect
            ;check for doubles
            fn.l=1
            If FileSize(f$+e$)>0
              While fn
                If FileSize(f$+"("+Str(fn)+")"+e$)<0
                  f$=f$+"("+Str(fn)+")"
                  Break
                EndIf
                fn+1
              Wend
            EndIf
            If fn=0
              conmsg("double file "+f$)
              Break
            EndIf
            
            If CreateFile(1,f$+e$)
              conmsg("Extracting "+F$+e$+#CRLF$)
              For i=1 To fl-2
                ch.a=ReadAsciiCharacter(0)
                c=c!ch
                WriteAsciiCharacter(1,ch)
              Next i
              CloseFile(1)
              csu.a=ReadAsciiCharacter(0);checksum
              If c<>csu
                conmsg("wrong data checksum for "+F$)
                Break
              EndIf
            Else
              conmsg("Write Error "+f$+e$)
            EndIf;If CreateFile(1,f$+e$)
            
            
          EndIf
        EndIf
      EndIf
    Wend
    CloseFile(0)
    conmsg ("done!")
  Else
    conmsg("cannot read "+ProgramParameter(0))
  EndIf;if ReadFile(0,"prb1.tap")
Else
  conmsg("usage: taprip filename.tap")
EndIf;If CountProgramParameters()
; IDE Options = PureBasic 5.30 (Windows - x86)
; ExecutableFormat = Console
; CursorPosition = 97
; FirstLine = 75
; Folding = -
; EnableUnicode
; EnableXP
; UseIcon = taprip.ico
; Executable = taprip.exe